---------------------------------------------------------------------------------------------
--------------------- Color Picker Class By Galuhad ----------------------
---------------------------------------------------------------------------------------------
---------------------------- Tweaked by Fortunis ------------------------------
---------------------------------------------------------------------------------------------


function Draw()

	-- Checks a color is between 0 and 1 ---------------------------------------------
	function ValidColorRange (colorValue)
		if (colorValue < 0) then
			return 0;
		elseif (colorValue > 1) then
			return 1;
		else
			return colorValue;
		end
	end

	function DEC_HEX(IN)
		-- simplified hex conversion -- G
		local OUT=string.rep("0",2)..string.format("%x",IN)
		return string.sub(string.len(OUT)-2,IN)
	end

	-- Create Colour Picker window/border.
	ColourPickerX = 219;
	ColourPickerY = 95;
	
	ColourPickerBorder:SetParent( OptWindow );
	ColourPickerBorder:SetPosition( ColourPickerX, ColourPickerY );
	ColourPickerBorder:SetSize( 242, 73 );
	ColourPickerBorder:SetBackColor( Turbine.UI.Color( 1, .2, .2, .2  ) );
	
	-- Draw color selector ---------------------------------------------------------

	mchaColourPicker:SetParent( OptWindow );
	mchaColourPicker:SetPosition(ColourPickerX+1, ColourPickerY+1);
	mchaColourPicker:SetSize(240, 71); 
	mchaColourPicker:SetBackground("/Fortunis/MCHA/images/picker.jpg");

	-- Draw color preview box ---------------------------------------------------------

	wPrevCurs:SetSize(26,26);
	wPrevCurs:SetPosition(0,0);
	wPrevCurs:SetBackColor(Turbine.UI.Color(0,0,0));
	wPrevCurs:SetZOrder(100);
	wPrevCurs:SetMouseVisible(false);
	wPrevCurs:SetVisible(false);

	wColorPrev:SetParent(wPrevCurs);
	wColorPrev:SetSize(22,22);
	wColorPrev:SetPosition(2,2);
	wColorPrev:SetBackColor(Turbine.UI.Color(1,1,1,1));
	wColorPrev:SetZOrder(101);
	wColorPrev:SetMouseVisible(false);
	wColorPrev:SetVisible(true);


	------------------------------------------------------------------------------------------------------
	---------------------- Fill colour selector with colours :D ------------------------

	wColorWin.GetColorFromCoord=function(sender,X,Y)
		-- Controls the visibility of the cursor window
		local blockXvalue = (math.floor(mchaColourPicker:GetWidth()/3));
		local blockYvalue = (math.floor(mchaColourPicker:GetHeight()/2));

		local curColor = Turbine.UI.Color();
		curColor.A = 1.0;
		local myX=X
		local myY=Y
		local curRed = 0;
		local curGreen = 0;
		local curBlue = 0;

		if (myX >= 0) and (myX < blockXvalue) then

			-- First color block = red to green
			curRed = 255-((255/blockXvalue)*myX);
			curGreen = (255/blockXvalue)*myX;
			curBlue = 0;

		elseif (myX >= blockXvalue) and (myX < (2*blockXvalue)) then

			-- Second color block = green to blue
			curRed = 0;
			curGreen = 255-((255/blockXvalue)*(myX - blockXvalue));
			curBlue = (255/blockXvalue)*(myX - blockXvalue);

		elseif (myX >= (2*blockXvalue)) then

			-- Third color block = blue to red
			curRed = (255/blockXvalue)*(myX - 2*blockXvalue);
			curGreen = 0;
			curBlue = 255-((255/blockXvalue)*(myX - 2*blockXvalue));

		end

		if myY <= blockYvalue then

			-- In the top block, so fade from black to full color
			curRed = curRed * (myY/blockYvalue);
			curGreen = curGreen * (myY/blockYvalue);
			curBlue = curBlue * (myY/blockYvalue);

		else

			-- In the bottom block, so fade from full color to white
			curRed = curRed + ((myY - blockYvalue) * ((255 - curRed)/(blockYvalue)));
			curGreen = curGreen + ((myY - blockYvalue) * ((255 - curGreen)/(blockYvalue)));
			curBlue = curBlue + ((myY - blockYvalue) * ((255 - curBlue)/(blockYvalue)));

		end

		curColor.R = (1/255) * curRed;
		curColor.G = (1/255) * curGreen;
		curColor.B = (1/255) * curBlue;
		return curColor;
	end
	mchaColourPicker.MouseMove = function(sender, args)
		mColor = wColorWin:GetColorFromCoord(args.X, args.Y)
		wColorPrev:SetBackColor(mColor);
		wPrevCurs:SetBackColor(Turbine.UI.Color((1-mColor.R),(1-mColor.G),(1-mColor.B)));
		wPrevCurs:SetPosition((Turbine.UI.Display.GetMouseX() - (wPrevCurs:GetWidth() / 2)), (Turbine.UI.Display.GetMouseY() - (wPrevCurs:GetHeight() / 2)));
		wPrevCurs:SetVisible(true);
	end
	mchaColourPicker.MouseLeave = function(sender, args)
		wPrevCurs:SetVisible(false);
	end

	mchaColourPicker.MouseClick = function(sender, args)
		colorString = wColorWin:GetColorFromCoord(args.X, args.Y)

		if (args.Button == Turbine.UI.MouseButton.Left) then

			-- Left mouse button click = set's colour option

			colTurbine =
			{
			["R"] = ValidColorRange(colorString.R);
			["G"] = ValidColorRange(colorString.G);
			["B"] = ValidColorRange(colorString.B);
			};

			--------------------------------------------------------------------------------------------
				mcha:SetBackColor(Turbine.UI.Color(colTurbine["R"], colTurbine["G"], colTurbine["B"]));
				redScrollBar:SetValue( colTurbine["R"] * 255);
				greenScrollBar:SetValue( colTurbine["G"] * 255);
				blueScrollBar:SetValue( colTurbine["B"] * 255);
			---------------------------------------------------------------------------------------------

		else

			-- Right mouse button = nothing
		end

	end
end
