print = Turbine.Shell.WriteLine;

MCHA = class(Turbine.UI.Window);

function LoadSettings()

	settings = Turbine.PluginData.Load(Turbine.DataScope.Account, "MCHA");
	if type(settings) ~= "table" then
		settings = { };
	end
	if settings.blendmode == nil or settings.bmode == nil then
		settings.blendmode = "3";
		settings.bmode = "Multiply";
		bmode = "Multiply";
	else
		bmode = settings.bmode;
	end
	if settings.InCom == nil then
		settings.InCom = false;
	end	
	if settings.oocp == nil then
		settings.oocp = "1";
		oocp = 1;
	else
		oocp = settings.oocp;
	end
	if settings.icp == nil then
		settings.icp = "1";
		icp = 1;
	else
		icp = settings.icp;
	end
	if settings.size == nil then
		settings.size = "100";
	end
	if settings.image == nil then
		settings.image = "mcha1";
		mcha.selectedItem = "mcha1";
	end
	if  settings.on == nil then
		settings.on = true;
		mchaCB:SetChecked(true);
	else
		mchaCB:SetChecked(settings.on);
	end
	if  settings.temp == nil then
		settings.temp = false;
		CombatOnlyCB:SetChecked(false);
	else
		CombatOnlyCB:SetChecked(settings.temp);
	end
	-- if not settings.delay then
		-- settings.delay = 0.5;
	-- end
	if not settings.color then
		settings.color = { };
		settings.color["0"] = "0";
		settings.color["1"] = "0";
		settings.color["2"] = "0";
		settings.color["3"] = "0";
	else
		color0 = tonumber(settings.color["0"]);
		color1 = tonumber(settings.color["1"]);
		color2 = tonumber(settings.color["2"]);
		color3 = tonumber(settings.color["3"]);
	end
	if settings.InCom == nil or settings.InCom == false then
		settings.InCom = False;
		CombatOnlyCB:SetChecked(false);
		ic = "off";
	else
		CombatOnlyCB:SetChecked(true);
		ic = "on";
	end
	if settings.ComSwap == nil or settings.ComSwap == false then
		settings.ComSwap = false;
		CombatSwapCB:SetChecked(false);
	else
		settings.ComSwap = true;
		CombatSwapCB:SetChecked(true);
	end
	if settings.trim == nil or settings.trim == "Solid" then
		trim = "Solid";
	else
		trim = "Transparent";
	end
	
	
	if settings.OWx == nil or settings.OWy == nil then
		settings.OWx = 200;
		settings.OWy = 150;
	end
	
	
	
	
	
	LoadWindow = Turbine.UI.Window();
	local xx, yy = Turbine.UI.Display.GetSize();
	LoadWindow:SetPosition( xx / 2 - ((xx / 3)) / 2, 50);
	LoadWindow:SetBackground( "Fortunis/MCHA/images/MCHA_Loaded.tga" );
	LoadWindow:SetSize( xx / 3, (xx / 3) * 1.0715);
	LoadWindow:SetStretchMode(2);
	LoadWindow:SetVisible( false );
	
	function LoadWindow:MouseClick()
		LoadWindow:SetVisible(false);
		settings.Date = tostring(Turbine.Engine.GetDate().Day);
		Turbine.PluginData.Save(Turbine.DataScope.Account, "MCHA", mcha.settings);
	end
	
	
	print( "<rgb=#FF9900>_______________________________________" );
	print( "<rgb=#FF9900>Mouse Cursor Highlighter Advanced Version " .. Version );
	print( "<rgb=#66FF00>by Fortunis of Laurelin has loaded" );
	print( "<rgb=#FF9900>_______________________________________" );
	mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. settings.image .. ".tga" );
	return settings;
end


function p1LoadSettings()

	if type(settings) ~= "table" then
		settings = { };
	end
	if settings.p1size == nil then
		settings.p1size = "150";
	end
	if settings.p1image == nil then
		settings.p1image = "mcha1";
	else
		settings.p1image = settings.p1image;
	end
	if settings.p1color == nil then
		settings.p1color = { };
		settings.p1color["0"] = "0";
		settings.p1color["1"] = "0";
		settings.p1color["2"] = "0";
		settings.p1color["3"] = "0";
	else
		p1color0 = tonumber(settings.p1color["0"]);
		p1color1 = tonumber(settings.p1color["1"]);
		p1color2 = tonumber(settings.p1color["2"]);
		p1color3 = tonumber(settings.p1color["3"]);
	end
	if settings.p1bmode == nil then
		settings.p1blendmode = "3";
		settings.p1bmode = "Multiply";
		blendmode = "3";
		bmode = "Multiply";
	elseif settings.p1bmode == "Color" then
		settings.p1blendmode = "1";
		settings.p1bmode = "Color";
		blendmode = "1";
		bmode = "Color";
	elseif settings.p1bmode == "Overlay" then
		settings.p1blendmode = "5";
		settings.p1bmode = "Overlay";
		blendmode = "5";
		bmode = "Overlay";
	elseif settings.p1bmode == "Screen" then
		settings.p1blendmode = "7";
		settings.p1bmode = "Screen";
		blendmode = "7";
		bmode = "Screen";
	elseif settings.p1bmode == "Multiply" then
		settings.p1blendmode = "3";
		settings.p1bmode = "Multiply";
		blendmode = "3";
		bmode = "Multiply";
	end
	-- if not settings.p1delay then
		-- settings.p1delay = 3.5;
	-- end
	if settings.p1InCom == nil or settings.p1InCom == false then
		settings.p1InCom = False;
		--CombatOnlyCB:SetChecked(false);
		ic = "off";
	else
		--CombatOnlyCB:SetChecked(true);
		ic = "on";
	end
	if settings.p1trim == nil or settings.p1trim == "Solid" then
		trim = "Solid";
	else
		trim = "Transparent";
	end
	mcha.selectedItem = settings.p1image;
	mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. settings.p1image .. ".tga" );
	return settings;

end


function p2LoadSettings()

	if type(settings) ~= "table" then
		settings = { };
	end
	if settings.p2size == nil then
		settings.p2size = "150";
	end
	if settings.p2image == nil then
		settings.p2image = "mcha1";
	else
		settings.p2image = settings.p2image;
	end
	if settings.p2color == nil then
		settings.p2color = { };
		settings.p2color["0"] = "0";
		settings.p2color["1"] = "0";
		settings.p2color["2"] = "0";
		settings.p2color["3"] = "0";
	else
		p2color0 = tonumber(settings.p2color["0"]);
		p2color1 = tonumber(settings.p2color["1"]);
		p2color2 = tonumber(settings.p2color["2"]);
		p2color3 = tonumber(settings.p2color["3"]);
	end
	if settings.p2bmode == nil then
		settings.p2blendmode = "3";
		settings.p2bmode = "Multiply";
		blendmode = "3";
		bmode = "Multiply";
	elseif settings.p2bmode == "Color" then
		settings.p2blendmode = "1";
		settings.p2bmode = "Color";
		blendmode = "1";
		bmode = "Color";
	elseif settings.p2bmode == "Overlay" then
		settings.p2blendmode = "5";
		settings.p2bmode = "Overlay";
		blendmode = "5";
		bmode = "Overlay";
	elseif settings.p2bmode == "Screen" then
		settings.p2blendmode = "7";
		settings.p2bmode = "Screen";
		blendmode = "7";
		bmode = "Screen";
	elseif settings.p2bmode == "Multiply" then
		settings.p2blendmode = "3";
		settings.p2bmode = "Multiply";
		blendmode = "3";
		bmode = "Multiply";
	end
	-- if not settings.p2delay then
		-- settings.p2delay = 3.5;
	-- end
	if settings.p2InCom == nil or settings.p2InCom == false then
		settings.p2InCom = False;
		--CombatOnlyCB:SetChecked(false);
		ic = "off";
	else
		CombatOnlyCB:SetChecked(true);
		ic = "on";
	end
	if settings.p2trim == nil or settings.p2trim == "Solid" then
		trim = "Solid";
	else
		trim = "Transparent";
	end
	mcha.selectedItem = settings.p2image;
	mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. settings.p2image .. ".tga" );
	return settings;

end


function p3LoadSettings()

	if type(settings) ~= "table" then
		settings = { };
	end
	if settings.p3size == nil then
		settings.p3size = "150";
	end
	if settings.p3image == nil then
		settings.p3image = "mcha1";
	else
		settings.p3image = settings.p3image;
	end
	if settings.p3color == nil then
		settings.p3color = { };
		settings.p3color["0"] = "0";
		settings.p3color["1"] = "0";
		settings.p3color["2"] = "0";
		settings.p3color["3"] = "0";
	else
		p3color0 = tonumber(settings.p3color["0"]);
		p3color1 = tonumber(settings.p3color["1"]);
		p3color2 = tonumber(settings.p3color["2"]);
		p3color3 = tonumber(settings.p3color["3"]);
	end
	if settings.p3bmode == nil then
		settings.p3blendmode = "3";
		settings.p3bmode = "Multiply";
		blendmode = "3";
		bmode = "Multiply";
	elseif settings.p3bmode == "Color" then
		settings.p3blendmode = "1";
		settings.p3bmode = "Color";
		blendmode = "1";
		bmode = "Color";
	elseif settings.p3bmode == "Overlay" then
		settings.p3blendmode = "5";
		settings.p3bmode = "Overlay";
		blendmode = "5";
		bmode = "Overlay";
	elseif settings.p3bmode == "Screen" then
		settings.p3blendmode = "7";
		settings.p3bmode = "Screen";
		blendmode = "7";
		bmode = "Screen";
	elseif settings.p3bmode == "Multiply" then
		settings.p3blendmode = "3";
		settings.p3bmode = "Multiply";
		blendmode = "3";
		bmode = "Multiply";
	end
	-- if not settings.p3delay then
		-- settings.p3delay = 3.5;
	-- end
	if settings.p3InCom == nil or settings.p3InCom == false then
		settings.p3InCom = False;
		--CombatOnlyCB:SetChecked(false);
		ic = "off";
	else
		CombatOnlyCB:SetChecked(true);
		ic = "on";
	end
	if settings.p3trim == nil or settings.p3trim == "Solid" then
		trim = "Solid";
	else
		trim = "Transparent";
	end
	mcha.selectedItem = settings.p3image;
	mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. settings.p3image .. ".tga" );
	return settings;

end









