
--Change this setting below if/when you add your own images to the set.

ImageAmount = 22; --When adding images, DO NOT skip any numbers on the filenames.

--Please bare in mind that youll need to do 2 versions of your image
--and place one in 'TransparentTrim' and the other in 'SolidTrim', keeping
--the same mcha[number] of the filename for both images.

--SolidTrim images have been created with 50% (approx) opacity in the areas needed
--for transparency and their trims left at full opacity (solid).
--TransparentTrim images have had their whole image opacity knocked down
--to 50% (approx). Obviously you dont need to follow this rule and you could have
--totally different images in the 2 folders if you want.



Version = "3.04";

import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.UI.Extensions";

import "Fortunis.MCHA.ColorPicker";
import "Fortunis.MCHA.Load";
import "Fortunis.MCHA.OptionsWindow";
import "Fortunis.MCHA.Save";

print = Turbine.Shell.WriteLine;

alphaScrollBar = Turbine.UI.Lotro.ScrollBar(); 			-- OptionsWindow
blendbutton = Turbine.UI.Lotro.Button(); 				-- OptionsWindow
blueScrollBar = Turbine.UI.Lotro.ScrollBar(); 			-- OptionsWindow
ColourPickerBorder = Turbine.UI.Window(); 				-- ColourPicker
ColourPickerCB = Turbine.UI.Lotro.CheckBox(); 			-- ColourPicker
CombatOnlyCB = Turbine.UI.Lotro.CheckBox(); 			-- OptionsWindow
CombatSwapCB = Turbine.UI.Lotro.CheckBox(); 			-- OptionsWindow
greenScrollBar = Turbine.UI.Lotro.ScrollBar(); 			-- OptionsWindow
icp = 1; 												-- All but ColorPick
imageBox = Turbine.UI.ListBox(); 						-- OptionsWindow
imageScroll = Turbine.UI.Lotro.ScrollBar(); 			-- OptionsWindow
LoadCheck = 0; 											-- Main
LoadScreen = 0; 										-- Main
mcha = Turbine.UI.Window(); 							-- All
MCHA = class(Turbine.UI.Window); 						-- Main
MCHABounds = class(Turbine.UI.Window); 					-- Main
mchaCB = Turbine.UI.Lotro.CheckBox(); 					-- OptionsWindow
mchaColourPicker = Turbine.UI.Window();					--
oocp = 1; 												-- All but ColorPick
redScrollBar = Turbine.UI.Lotro.ScrollBar(); 			-- OptionsWindow
sizeScrollBar = Turbine.UI.Lotro.ScrollBar();			-- OptionsWindow
wPrevCurs = Turbine.UI.Window();						-- ColourPicker
wColorPrev = Turbine.UI.Window();						-- ColourPicker
wColorWin = Turbine.UI.Window(); 						-- ColourPicker



function MCHABounds:Constructor(parent)
	Turbine.UI.Window.Constructor(self);

	self:SetSize(11, 11);
	self:SetMouseVisible(true);
	self.parent = parent;
	self:SetZOrder(10000);
end

function MCHABounds:MouseEnter(sender, args)
	self.parent:SetVisible(false);
	self.parent.up:SetMouseVisible(false);
	self.parent.left:SetMouseVisible(false);
	self.parent.right:SetMouseVisible(false);
	self.parent.down:SetMouseVisible(false);
end



function MCHA:Constructor()
	Turbine.UI.Window.Constructor(self);

	self.settings = Fortunis.MCHA.LoadSettings();

	local x, y = Turbine.UI.Display:GetMousePosition();
	self.x = x;
	self.y = y;
	self.t = Turbine.Engine.GetGameTime();
	if sizeScrollBar:GetValue() == nil then
		self:SetPosition(x - settings.size /2, y - settings.size /2);
	else
		self:SetPosition(x - sizeScrollBar:GetValue() / 2, y - sizeScrollBar:GetValue() / 2);
	end
	self:SetSize(self.settings.size, self.settings.size);
	self:SetStretchMode(2);
	self:SetBackColor(Turbine.UI.Color(tonumber(settings.color["0"]), tonumber(settings.color["1"]), tonumber(settings.color["2"]), tonumber(settings.color["3"])));
	self:SetBackColorBlendMode(settings.blendmode);
	self:SetVisible(false);
	self:SetMouseVisible(false);
	self:SetWantsUpdates(self.settings.on);
	self:SetZOrder(10000);
	if  settings.image == nil then
		Himage = "mcha1";
	else
		Himage = settings.image;
	end
	if settings.trim == nil or settings.trim == "Solid" then
		trim = "Solid";
	else
		trim = "Transparent";
	end
	self:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. Himage .. ".tga" );

	self.up = MCHABounds(self);
	self.down = MCHABounds(self);
	self.left = MCHABounds(self);
	self.right = MCHABounds(self);

end



------------------------------------------------------------
------------ Command line Code -------------
------------------------------------------------------------

MCHACommand = class(Turbine.ShellCommand);

mchaCommand = MCHACommand();
Turbine.Shell.AddCommand("mcha", mchaCommand);
mcha = MCHA();

function MCHACommand:Execute(command, arg)
	OptWindow:Constructor();

	
-- [/mcha] -- opens options menu
	if arg == "" then
		if OptWindow:IsVisible(true) then
			OptWindow:SetVisible( false );
			OptWindow:Activate( false );
		else
			OptWindow:SetVisible( true );
			OptWindow:Activate( true );
		end
		if settings.trim == nil or settings.trim == "Solid" then
			trim = "Solid";
		else
			trim = "Transparent";
		end
		mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. settings.image .. ".tga" );
		self.selectedItem = settings.image;
		Himage = settings.image;
		if settings.InCom == nil or settings.InCom == false then
			settings.InCom = False;
			CombatOnlyCB:SetChecked(false);
		else
			CombatOnlyCB:SetChecked(true);
		end
		CombatSwapAble();
	end
	

-- [/mcha toggle] -- turns mcha on and off
	if arg == "toggle" then
		if mcha.settings.on then
			mcha.settings.on = false;
			mcha:SetWantsUpdates(false);
			mcha:SetVisible(false);
			mchaCB:SetChecked(false);
			print("MCHA is off.");
		else
			mcha.settings.on = true;
			mcha:SetWantsUpdates(true);
			mchaCB:SetChecked(true);
			print("MCHA is on.");
		end

		
-- [/mcha profile1] -- loads profile1 settings
	elseif arg == "profile1" then
		
		mcha:Pro1();
		
		
-- [/mcha profile2] -- loads profile2 settings
	elseif arg == "profile2" then
		
		mcha:Pro2();

		
-- [/mcha profile3] -- loads profile3 settings
	elseif arg == "profile3" then
		
		mcha:Pro3();
		
	end
	
	
end



function MCHA:Update()
	local x, y = Turbine.UI.Display:GetMousePosition();
	local t = Turbine.Engine.GetGameTime();
	local tem = sizeScrollBar:GetValue() / 2;
	if sSB == nil then
		mcha:SetPosition(x - settings.size / 2, y - settings.size / 2);
		--print("settings.size = " .. settings.size);
	else
		mcha:SetPosition(x - tem, y - tem);
		--print("tem = " .. tem);
	end
	--print("sSB = " .. sSB);
	mcha.up:SetPosition(x - 500, y - 12);
	mcha.left:SetPosition(x - 12, y - 5);
	mcha.right:SetPosition(x + 1, y - 5);
	mcha.down:SetPosition(x - 5, y + 1);
	mcha.up:SetMouseVisible(true);
	mcha.left:SetMouseVisible(true);
	mcha.right:SetMouseVisible(true);
	mcha.down:SetMouseVisible(true);


	
	if mchaCB:IsChecked(true) then
	
		if CombatOnlyCB:IsChecked(true) then
			Player = Turbine.Gameplay.LocalPlayer.GetInstance();
			mcha:SetVisible(false);
			
			if Player:IsInCombat(true) then
				mcha:SetVisible(true);
				
				if settings.icp == "1" then
					mcha:Pro1();
				elseif settings.icp == "2" then
					mcha:Pro2();
				elseif settings.icp == "3" then
					mcha:Pro3();
				end
				
			end
		else
			mcha:SetVisible(true);
		end
		
		
		if CombatSwapCB:IsChecked(true) then
			Player = Turbine.Gameplay.LocalPlayer.GetInstance();
			mcha:SetVisible( true );
			if Player:IsInCombat(true) then
				if settings.icp == "1" then
					mcha:Pro1();
				elseif settings.icp == "2" then
					mcha:Pro2();
				elseif settings.icp == "3" then
					mcha:Pro3();
				end
			else
				if oocp == "1" then
					mcha:Pro1();
				elseif oocp == "2" then
					mcha:Pro2();
				elseif oocp == "3" then
					mcha:Pro3();
				end
			end
		end	

	else
		mcha:SetVisible(false);
	end
	
	if WasOnn == 1 then
		mcha:SetVisible(false);
	elseif not WasOnn == 1 and CombatOnlyCB:IsChecked(false) then
		mcha:SetVisible(true);
	end
	
	if settings.Date == tostring(Turbine.Engine.GetDate().Day) then 
		LoadWindow:SetVisible( false );
	else
		if LoadCheck == 0 then
			if LoadScreen <= 800 then
				LoadScreen = LoadScreen + 1;
			else
				LoadWindow:SetVisible( false );
				LoadCheck = 1;
				settings.Date = tostring(Turbine.Engine.GetDate().Day);
				Turbine.PluginData.Save(Turbine.DataScope.Account, "MCHA", mcha.settings);
			end
		end
	end
	
	
	mcha:SetWantsKeyEvents(true);
	
	mcha.KeyDown = function(sender,args)
	
		if (args.Action == 268435635)then
			if(OptWindow:IsVisible() == true)then
				--OptWindow:SetVisible(false);
				WasOn = 1;
			elseif WasOn == 1 then
				OptWindow:SetVisible(true);
				WasOn = 0;
			end
			if(mcha:IsVisible() == true)then
				--mcha:SetVisible(false);
				WasOnn = 1;
			elseif WasOnn == 1 then
				--mcha:SetVisible(true);
				WasOnn = 0;
			end
		end
	end	
	
	if WasOn == 1 then
		OptWindow:SetVisible(false);
	end
	
end



function imageBox.SelectedIndexChanged ( sender )
	
	selectedItem = imageBox:GetItem(sender:GetSelectedIndex());
	selectedImage = ( "mcha" .. sender:GetSelectedIndex() );
	for i = 1, ImageAmount do
		local item = imageBox:GetItem(i);	
		item:SetForeColor( Turbine.UI.Color(1, 1, 1, 1) );
		item:SetBackColor( Turbine.UI.Color(1, 0, 0, .4) );
	end			
	selectedItem:SetForeColor( Turbine.UI.Color(1, 1, .8, 0) );
	selectedItem:SetBackColor( Turbine.UI.Color(1, 0, 0, .7) );
	
	mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. selectedImage .. ".tga" );
	mcha.selectedItem = selectedImage;
	Himage = selectedImage;
	imageBox:SetVisible( false );
	imageScroll:SetVisible( false );
	return;
end


--#########################################################################################
--#########################################################################################

function mcha:Pro1()

	self.settings = p1LoadSettings();
	--MCHA:p1LoadSettings();
	-- Set Image and its associated variables
	mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. settings.p1image .. ".tga" );
	self.selectedItem = self.settings.p1image;
	Himage = self.settings.p1image;
	-- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	-- Set Size and its associated variables
	mcha:SetSize(self.settings.p1size, self.settings.p1size);
	sizeScrollBar:SetValue(self.settings.p1size);
	settings.size = settings.p1size;
	--sSB = self.settings.p1size;
	-- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	-- Set Color and its associated variables
	p1color0 = tonumber(settings.p1color["0"]);
	p1color1 = tonumber(settings.p1color["1"]);
	p1color2 = tonumber(settings.p1color["2"]);
	p1color3 = tonumber(settings.p1color["3"]);
	
	--bmode = settings.p1bmode;
	--blendmode = settings.p1blendmode;
	blendbutton:SetText( "Blend Mode = p1." .. self.settings.p1bmode);
	self:SetBackColorBlendMode(settings.p1blendmode);
	
	mcha:SetBackColor( Turbine.UI.Color( p1color0, p1color1, p1color2, p1color3 ) );
	alphaScrollBar:SetValue( p1color0 * 255);
	redScrollBar:SetValue( p1color1 * 255);
	greenScrollBar:SetValue( p1color2 * 255);
	blueScrollBar:SetValue( p1color3 * 255);
	
	mcha.settings.oocp = tostring(oocp);
	mcha.settings.icp = tostring(icp);
end

--#########################################################################################
--#########################################################################################

function mcha:Pro2()

	self.settings = p2LoadSettings();
	--MCHA:p2LoadSettings();
	-- Set Image and its associated variables
	mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. settings.p2image .. ".tga" );
	self.selectedItem = self.settings.p2image;
	Himage = self.settings.p2image;
	-- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	-- Set Size and its associated variables
	mcha:SetSize(self.settings.p2size, self.settings.p2size);
	sizeScrollBar:SetValue(self.settings.p2size);
	settings.size = settings.p2size;
	--sSB = self.settings.p2size;
	-- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	-- Set Color and its associated variables
	p2color0 = tonumber(settings.p2color["0"]);
	p2color1 = tonumber(settings.p2color["1"]);
	p2color2 = tonumber(settings.p2color["2"]);
	p2color3 = tonumber(settings.p2color["3"]);
	
	--bmode = settings.p2bmode;
	--blendmode = settings.p2blendmode;
	blendbutton:SetText( "Blend Mode = p2." .. self.settings.p2bmode);
	self:SetBackColorBlendMode(settings.p2blendmode);
	
	mcha:SetBackColor( Turbine.UI.Color( p2color0, p2color1, p2color2, p2color3 ) );
	alphaScrollBar:SetValue( p2color0 * 255);
	redScrollBar:SetValue( p2color1 * 255);
	greenScrollBar:SetValue( p2color2 * 255);
	blueScrollBar:SetValue( p2color3 * 255);
	
	mcha.settings.oocp = tostring(oocp);
	mcha.settings.icp = tostring(icp);
end

--#########################################################################################
--#########################################################################################

function mcha:Pro3()

	self.settings = p3LoadSettings();
	--MCHA:p3LoadSettings();
	-- Set Image and its associated variables
	mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. settings.p3image .. ".tga" );
	self.selectedItem = self.settings.p3image;
	Himage = self.settings.p3image;
	-- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	-- Set Size and its associated variables
	mcha:SetSize(self.settings.p3size, self.settings.p3size);
	sizeScrollBar:SetValue(self.settings.p3size);
	settings.size = settings.p3size;
	--sSB = self.settings.p3size;
	-- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	-- Set Color and its associated variables
	p3color0 = tonumber(settings.p3color["0"]);
	p3color1 = tonumber(settings.p3color["1"]);
	p3color2 = tonumber(settings.p3color["2"]);
	p3color3 = tonumber(settings.p3color["3"]);
	
	--bmode = settings.p3bmode;
	--blendmode = settings.p3blendmode;
	blendbutton:SetText( "Blend Mode = p3." .. self.settings.p3bmode);
	self:SetBackColorBlendMode(settings.p3blendmode);
	
	mcha:SetBackColor( Turbine.UI.Color( p3color0, p3color1, p3color2, p3color3 ) );
	alphaScrollBar:SetValue( p3color0 * 255);
	redScrollBar:SetValue( p3color1 * 255);
	greenScrollBar:SetValue( p3color2 * 255);
	blueScrollBar:SetValue( p3color3 * 255);
	
	mcha.settings.oocp = tostring(oocp);
	mcha.settings.icp = tostring(icp);
end




--#########################################################################################
--#########################################################################################


-------------------------------------------------------
--------- CheckBox Change State Functions -------------
-------------------------------------------------------


function ColourPickerCB:CheckedChanged(sender, args)
	if ColourPickerCB:IsChecked() then	
		ColourPickerBorder:SetVisible ( true );
		Draw();
		mchaColourPicker:SetVisible ( true );
	else
		ColourPickerBorder:SetVisible ( false );
		mchaColourPicker:SetVisible ( false );
	end
end

function CombatSwapCB:CheckedChanged(sender, args)
	CombatOnlyCB:SetChecked( false );
	CombatSwapAble();
end

function CombatSwapAble()
	local disabled = Turbine.UI.Color( .2, .2, .2 );
	local enabled = Turbine.UI.Color( .75, .65, 0 );
	local wenabled =  Turbine.UI.Color( 1, 1, 1 );
	
	if CombatSwapCB:IsChecked( true ) then

		imagebutton:SetForeColor( disabled );
		trimbutton:SetForeColor( disabled );
		blendbutton:SetForeColor( disabled );

		alphalabel:SetBackColor( disabled );
		bluelabel:SetBackColor( disabled );
		greenlabel:SetBackColor( disabled );
		redlabel:SetBackColor( disabled );
		sizelabel:SetBackColor( disabled );
		
		alphalabel:SetForeColor( disabled );
		bluelabel:SetForeColor( disabled );
		greenlabel:SetForeColor( disabled );
		redlabel:SetForeColor( disabled );
		sizelabel:SetForeColor( disabled );
		
		mchaColourPicker:SetBackground("/Fortunis/MCHA/images/blank.tga");
		
		ColourPickerCB:SetEnabled( false );
		ColourPickerCB:SetForeColor( disabled );
	else
		imagebutton:SetForeColor( enabled );
		trimbutton:SetForeColor( enabled );
		blendbutton:SetForeColor( enabled );
		
		
		alphalabel:SetBackColor( Turbine.UI.Color( 0.5, 0.3, 0.3, 0.3 ) );
		sizelabel:SetBackColor( Turbine.UI.Color( 1, 0.7, 0.5, 0.1 ) );
		bluelabel:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0.6 ) );
		greenlabel:SetBackColor( Turbine.UI.Color( 1, 0, 0.6, 0 ) );
		redlabel:SetBackColor( Turbine.UI.Color( 1, 0.6, 0, 0 ) );
		
		alphalabel:SetForeColor( wenabled );
		bluelabel:SetForeColor( wenabled );
		greenlabel:SetForeColor( wenabled );
		redlabel:SetForeColor( wenabled );
		sizelabel:SetForeColor( wenabled );
		
		mchaColourPicker:SetBackground("/Fortunis/MCHA/images/picker.jpg");
		
		ColourPickerCB:SetEnabled( true );
		ColourPickerCB:SetForeColor( wenabled );
	end
end

function CombatOnlyCB:CheckedChanged(sender, args)
	if CombatOnlyCB:IsChecked( true ) then
		CombatSwapCB:SetChecked( false );
		CombatOnlyCB:SetChecked( true );
	end
end

-- function mchaCB:CheckedChanged(sender, args)
-- print ( "What the hell is going on!!!" );
	-- if mchaCB:IsChecked( true )  and CombatOnlyCB:IsChecked( false ) then
		-- mcha:SetVisible ( true );
	-- elseif mchaCB:IsChecked( false ) then
		-- mcha:SetVisible ( false );
	-- end
-- end
