print = Turbine.Shell.WriteLine;

OptWindow = Turbine.UI.Lotro.Window();

function OptWindow:Constructor()

	
	-- Create a main window to display options.
	
	OptWindow:SetPosition( settings.OWx, settings.OWy );
	OptWindow:SetSize( 492, 480 );
	OptWindow:SetText( "Mouse Cursor Highlighter Advanced" );
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --



	--##################################################################
	-- OPTIONS MENU TOP SECTION
	--##################################################################
	
	
	
	-- Create a MCHA on/off checkbox and text.
	mchaCB:SetParent( OptWindow );
	mchaCB:SetMultiline( true );
	mchaCB:SetPosition( 40, 49 );
	mchaCB:SetSize( 105, 25 );
	mchaCB:SetText( " MCHA on/off" );
	mchaCB:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Create image select button and add it to the window.
	imagebutton = Turbine.UI.Lotro.Button();
	imagebutton:SetParent( OptWindow );
	imagebutton:SetText( "Highlighter Select" );
	imagebutton:SetPosition( 25, 120 );
	imagebutton:SetSize( 180, 20 );
	
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
		
	-- Clicking Image Select Button.
	imageBox:SetVisible( false );
	
	imagebutton.Click = function( sender, args )
		
		if not CombatSwapCB:IsChecked() then
		
			if imageBox:IsVisible() then		
				imageBox:SetVisible( false );
				imageScroll:SetVisible( false );
			else
			
				if imageItem == nil then
					
					imageBox:SetParent( OptWindow );
					imageBox:SetSize( imagebutton:GetWidth() - 3, 200 );
					imageBox:SetPosition( imagebutton:GetLeft() + 1, imagebutton:GetTop() + imagebutton:GetHeight() + 2 );
					imageBox:SetBackColor( Turbine.UI.Color( 1, 0, 0, .4 ) );
					imageBox:SetMouseVisible( true );
					
					imageScroll:SetOrientation( Turbine.UI.Orientation.Vertical );
					imageScroll:SetParent(OptWindow);
					imageScroll:SetPosition( imageBox:GetLeft() + imageBox:GetWidth() - 10, imageBox:GetTop() + 5 )
					imageScroll:SetSize(10, imageBox:GetHeight() - 5 );
					
					imageBox:SetVerticalScrollBar( imageScroll );	

				
					imageItem = Turbine.UI.Label();
					imageItem:SetSize( 100, 20 );
					imageItem:SetFont( Turbine.UI.Lotro.Font.TrajanPro18 );
					
					for i = 1, ImageAmount do
					
						listItem = Turbine.UI.Label();
						listItem:SetSize( imagebutton:GetWidth() - 3, 17 );
						listItem:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 );
						listItem:SetText( "mcha" .. i );
						imageBox:AddItem( listItem );
					end				
				end
				
				imageBox:SetVisible( true );
				imageScroll:SetVisible( true );
				
			end
		end
	end	
		
		
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Create image trim change button and add it to the window.
	trimbutton = Turbine.UI.Lotro.Button();
	trimbutton:SetParent( OptWindow );
	trimbutton:SetText( "Trim Toggle" );
	trimbutton:SetPosition( 25, 90 );
	trimbutton:SetSize( 180, 20 );

	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

		
	-- Clicking Image Trim Button 

	trimbutton.Click = function( sender, args )		
		if trim == "Solid" then
			trim = "Transparent";
		else	
			trim = "Solid";
		end
		if mcha.selectedItem == nil then
			mcha.selectedItem = "mcha1";
		end
		mcha:SetBackground( "Fortunis/MCHA/images/" .. trim .. "Trim/" .. mcha.selectedItem .. ".tga" );
		
	end
	
	
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Create blend change button and add it to the window.
	
	blendbutton:SetParent( OptWindow );
	blendbutton:SetText( "Blend Mode = " .. bmode);
	blendbutton:SetPosition( 25, 150 );
	blendbutton:SetSize( 180, 20 );

	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

		
	-- Clicking blend change Button 
	
	blendbutton.Click = function( sender, args )	
		--blendbutton:SetText( "Blend Mode = " .. bmode);
		if bmode == "Multiply" then
			mcha:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
			--print( "Blend Mode is Color" );
			settings.blendmode = "1";
			settings.bmode = "Color";
			bmode = "Color";
		elseif bmode == "Color" then
			mcha:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay);
			--print( "Blend Mode is Overlay" );
			settings.blendmode = "5";
			settings.bmode = "Overlay";
			bmode = "Overlay";
		elseif bmode == "Overlay" then
			mcha:SetBackColorBlendMode(Turbine.UI.BlendMode.Screen);
			--print( "Blend Mode is Screen" );
			settings.blendmode = "7";
			settings.bmode = "Screen";
			bmode = "Screen";
		elseif bmode == "Screen" then
			mcha:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply);
			--print( "Blend Mode is Multiply" );
			settings.blendmode = "3";
			settings.bmode = "Multiply";
			bmode = "Multiply";
		end
		blendbutton:SetText( "Blend Mode = " .. bmode);
	end
	
	
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

		
	-- Create alpha label and slider.
	alphalabel = Turbine.UI.Label();
	alphalabel:SetParent( OptWindow );
	alphalabel:SetText( "Alpha" );
	alphalabel:SetPosition( 220, 55 );
	alphalabel:SetSize( 240, 11 );
	alphalabel:SetBackColor( Turbine.UI.Color( 0.5, 0.3, 0.3, 0.3 ) );
	alphalabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	
	alphaScrollBar:SetParent( alphalabel );
	alphaScrollBar:SetPosition( 0, 1 );
	alphaScrollBar:SetSize( 240, 10 );
	alphaScrollBar:SetMinimum( 0 );
	alphaScrollBar:SetMaximum( 255 );
	alphaScrollBar:SetValue( settings.color["0"] * 255);
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Create size label and slider.
	sizelabel = Turbine.UI.Label();
	sizelabel:SetParent( OptWindow );
	sizelabel:SetText( "Size" );
	sizelabel:SetPosition( 220, 75 );
	sizelabel:SetSize( 240, 11 );
	sizelabel:SetBackColor( Turbine.UI.Color( 1, 0.7, 0.5, 0.1 ) );
	sizelabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	
	sizeScrollBar:SetParent( sizelabel );
	sizeScrollBar:SetPosition( 0, 1 );
	sizeScrollBar:SetSize( 240, 10 );
	sizeScrollBar:SetMinimum( 10 );
	sizeScrollBar:SetMaximum( 600 );
	sizeScrollBar:SetValue( settings.size );
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	
	-- Create red label and slider.
	redlabel = Turbine.UI.Label();
	redlabel:SetParent( OptWindow );
	redlabel:SetText( "Red" );
	redlabel:SetPosition( 220, 106 );
	redlabel:SetSize( 240, 11 );
	redlabel:SetBackColor( Turbine.UI.Color( 1, 0.6, 0, 0 ) );
	redlabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	redScrollBar:SetParent( redlabel );
	redScrollBar:SetPosition( 0, 1);
	redScrollBar:SetSize( 240, 10 );
	redScrollBar:SetMinimum( 0 );
	redScrollBar:SetMaximum( 255 );
	redScrollBar:SetValue( settings.color["1"] * 255);
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	
	-- Create green label and slider.
	greenlabel = Turbine.UI.Label();
	greenlabel:SetParent( OptWindow );
	greenlabel:SetText( "Green");
	greenlabel:SetPosition( 220, 126 );
	greenlabel:SetSize( 240, 11 );
	greenlabel:SetBackColor( Turbine.UI.Color( 1, 0, 0.6, 0 ) );
	greenlabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	greenScrollBar:SetParent( greenlabel );
	greenScrollBar:SetPosition( 0, 1);
	greenScrollBar:SetSize( 240, 10 );
	greenScrollBar:SetMinimum( 0 );
	greenScrollBar:SetMaximum( 255 );
	greenScrollBar:SetValue( settings.color["2"] * 255);
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	
	-- Create blue label and slider.
	bluelabel = Turbine.UI.Label();
	bluelabel:SetParent( OptWindow );
	bluelabel:SetText( "Blue" );
	bluelabel:SetPosition( 220, 146 );
	bluelabel:SetSize( 240, 11 );
	bluelabel:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0.6 ) );
	bluelabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	
	blueScrollBar:SetParent( bluelabel );
	blueScrollBar:SetPosition( 0, 1);
	blueScrollBar:SetSize( 240, 10 );
	blueScrollBar:SetMinimum( 0 );
	blueScrollBar:SetMaximum( 255 );
	blueScrollBar:SetValue( settings.color["3"] * 255);
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	
		
		
	self.Update = function( sender, args )
		mcha:SetBackColor( Turbine.UI.Color( alphaScrollBar:GetValue() / 255, redScrollBar:GetValue() / 255, greenScrollBar:GetValue() / 255, blueScrollBar:GetValue() / 255 ) );
		mcha:SetSize(sizeScrollBar:GetValue(), sizeScrollBar:GetValue());
		mcha:SetStretchMode(2);
		sSB = sizeScrollBar:GetValue();
		
		local x, y = Turbine.UI.Display:GetMousePosition();
		
		if sizeScrollBar:GetValue() == nil then
			--mcha:SetPosition(x - settings.size / 2, y - settings.size / 2);
		else
			--mcha:SetPosition(x - sizeScrollBar:GetValue() / 2, y - sizeScrollBar:GetValue() / 2);
		end
		
	end
	
	alphaScrollBar.ValueChanged = self.Update;
	redScrollBar.ValueChanged = self.Update;
	greenScrollBar.ValueChanged = self.Update;
	blueScrollBar.ValueChanged = self.Update;
	sizeScrollBar.ValueChanged = self.Update;
	
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

	-----------------------------------------------------------------------------------
	-- Create Colour Picker is handled in ColorPicker.lua
	-----------------------------------------------------------------------------------
	

	-- Create Colour Picker toggle checkbox.
	ColourPickerCB:SetParent( OptWindow );
	ColourPickerCB:SetMultiline( true );
	ColourPickerCB:SetPosition( 256, 177 );
	ColourPickerCB:SetSize( 167, 25 );
	ColourPickerCB:SetText( " Colour Picker Toggle" );
	ColourPickerCB:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --	
	

	--##################################################################
	-- OPTIONS MENU MIDDLE SECTION
	--##################################################################

	-- Create line break.
	local linebreak = Turbine.UI.Label();
	linebreak:SetParent( OptWindow );
	linebreak:SetPosition( 3, 210 );
	linebreak:SetSize( 486, 1 );
	linebreak:SetForeColor( Turbine.UI.Color( 0, 1, 0 ) );
	linebreak:SetBackColor( Turbine.UI.Color( 1, 1, 1, 1 ) );
	linebreak:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );

	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

	
	-- Create Combat only checkbox and text.
	CombatOnlyCB:SetParent( OptWindow );
	CombatOnlyCB:SetMultiline( true );
	CombatOnlyCB:SetPosition( 40, 230 );
	CombatOnlyCB:SetSize( 105, 25 );
	CombatOnlyCB:SetText( " Combat Only" );
	CombatOnlyCB:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
	
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

	
	-- Create CombatSwap checkbox and text.
	CombatSwapCB:SetParent( OptWindow );
	CombatSwapCB:SetMultiline( true );
	CombatSwapCB:SetPosition( 40, 265 );
	CombatSwapCB:SetSize( 160, 25 );
	CombatSwapCB:SetText( " Combat Swap Profile" );
	CombatSwapCB:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Create in combat profile button.
	icp = settings.icp;
	local icpbutton = Turbine.UI.Lotro.Button();
	icpbutton:SetParent( OptWindow );
	icpbutton:SetText( "In Combat = Profile " .. icp );
	icpbutton:SetPosition( 270, 265 );
	icpbutton:SetSize( 200, 20 );
	
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

	-- Clicking in combat profile Button 
	
	icpbutton.Click = function( sender, args )		
		if icp == "1" then
			icp = "2";
			settings.icp = "2";
		elseif 	icp == "2" then
			icp = "3";
			settings.icp = "3";
		elseif 	icp == "3" then
			icp = "1";
			settings.icp = "1";
		end
		icpbutton:SetText( "In Combat = Profile " .. icp );
		--mcha.settings.oocp = tostring(oocp);
		--mcha.settings.icp = tostring(icp);
	end
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Create out of combat profile button.
	oocp = settings.oocp;
	local oocpbutton = Turbine.UI.Lotro.Button();
	oocpbutton:SetParent( OptWindow );
	oocpbutton:SetText( "Out of Combat = Profile " .. oocp );
	oocpbutton:SetPosition( 270, 230 );
	oocpbutton:SetSize( 200, 20 );

	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Clicking out of combat profile Button 
	
	oocpbutton.Click = function( sender, args )		
		if oocp == "1" then
			oocp = "2";
			settings.oocp = 2;
		elseif 	oocp == "2" then
			oocp = "3";
			settings.oocp = "3";
		elseif 	oocp == "3" then
			oocp = "1";
			settings.oocp = "1";
		end
		oocpbutton:SetText( "Out of Combat = Profile " .. oocp );
		--mcha.settings.oocp = tostring(oocp);
		--mcha.settings.icp = tostring(icp);
	end

	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --



	
	--##################################################################
	-- OPTIONS MENU BOTTOM SECTION
	--##################################################################


	-- Create line break.
	local linebreak = Turbine.UI.Label();
	linebreak:SetParent( OptWindow );
	linebreak:SetPosition( 3, 305 );
	linebreak:SetSize( 486, 1 );
	linebreak:SetForeColor( Turbine.UI.Color( 0, 1, 0 ) );
	linebreak:SetBackColor( Turbine.UI.Color( 1, 1, 1, 1 ) );
	linebreak:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );

	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Create save profile 1 button.
	local pro1button = Turbine.UI.Lotro.Button();
	pro1button:SetParent( OptWindow );
	pro1button:SetText( "Save Profile 1" );
	pro1button:SetPosition( 25, 320 );
	pro1button:SetSize( 150, 20 );

	pro1button.Click = function( sender, args )		
		--mcha.settings.p1image = Himage;
		p1SaveSettings();
	end
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

		
	-- Create save profile 2 button.
	local pro2button = Turbine.UI.Lotro.Button();
	pro2button:SetParent( OptWindow );
	pro2button:SetText( "Save Profile 2" );
	pro2button:SetPosition( 25, 360 );
	pro2button:SetSize( 150, 20 );

	pro2button.Click = function( sender, args )		
		--mcha.settings.p2image = Himage;
		p2SaveSettings();
	end
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --

	
	-- Create save profile 3 button.
	local pro3button = Turbine.UI.Lotro.Button();
	pro3button:SetParent( OptWindow );
	pro3button:SetText( "Save Profile 3" );
	pro3button:SetPosition( 25, 400 );
	pro3button:SetSize( 150, 20 );

	pro3button.Click = function( sender, args )		
		--mcha.settings.p3image = Himage;
		p3SaveSettings();
	end
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	
	
	-- Create usage text Header for Profiles.
	local pro1label = Turbine.UI.Label();
	pro1label:SetParent( OptWindow );
	pro1label:SetText( "Profile Usage" );
	pro1label:SetPosition( 190, 320 );
	pro1label:SetSize( 280, 15 );
	pro1label:SetForeColor( Turbine.UI.Color( 0, 1, 0 ) );
	pro1label:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0.3 ) );
	pro1label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	
	-- Create usage body text 1 for Profiles.
	local pro1label = Turbine.UI.Label();
	pro1label:SetParent( OptWindow );
	pro1label:SetText( "After saving a profile, use" );
	pro1label:SetPosition( 190, 340 );
	pro1label:SetSize( 280, 15 );
	pro1label:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	pro1label:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0.3 ) );
	pro1label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	
	-- Create usage body text 2 for Profiles.
	local pro1label = Turbine.UI.Label();
	pro1label:SetParent( OptWindow );
	pro1label:SetText( "/shortcut Q /mcha profileN" );
	pro1label:SetPosition( 190, 360 );
	pro1label:SetSize( 280, 15 );
	pro1label:SetForeColor( Turbine.UI.Color( 1, 1, 0 ) );
	pro1label:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0.3 ) );
	pro1label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	
	-- Create usage body text 3 for Profiles.
	local pro1label = Turbine.UI.Label();
	pro1label:SetParent( OptWindow );
	pro1label:SetText( "  (Q is the number of the Quickslot)      (N is the number of the profile)   to link it to a quickslot" );
	pro1label:SetPosition( 190, 390 );
	pro1label:SetSize( 280, 35 );
	pro1label:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) );
	pro1label:SetBackColor( Turbine.UI.Color( 1, 0, 0, 0.3 ) );
	pro1label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
	-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --


	-- Create save general settings button.
	local savebutton = Turbine.UI.Lotro.Button();
	savebutton:SetParent( OptWindow );
	savebutton:SetText( "Save General Settings" );
	savebutton:SetPosition( 320, 440 );
	savebutton:SetSize( 150, 20 );

	savebutton.Click = function( sender, args )
		SaveSettings();
	end	
	
end


	--##################################################################



-- Detect MCHA window close and register false visible. Also save its position.
function OptWindow:Closed(sender, args)
	OptWindow:SetVisible(false);
end	

-- Detect Options Window position change and save its position.
function OptWindow:PositionChanged(sender, args)
	SaveSettings(1);
end

return;